#include <windows.h>
#include <DispEx.h>
#include "tp_stub.h"
#include <stdio.h>

static void log(const tjs_char *format, ...)
{
	va_list args;
	va_start(args, format);
	tjs_char msg[1024];
	_vsnwprintf(msg, 1024, format, args);
	TVPAddLog(msg);
	va_end(args);
}

//---------------------------------------------------------------------------

#if 0
/**
 * OLE -> gg CxgfBXpb`
 * sender (IUnknown)  DIID ̃Cxg󗝂A
 * receiver (tTJSDispatch2) ɑMB
 */ 
class SuperSink : public IDispatch
{
protected:
	REFIID diid;
	//CComPtr<IUnkown> sender;
	DWORD cookie;
	
	VNBSink(IUnkown *sender, GUID diid) {

		// advise 
	}

	//----------------------------------------------------------------------------
	// IUnknown 
	
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
											 void __RPC_FAR *__RPC_FAR *ppvObject) {
		if (riid == IID_IUnknown ||
			riid == IID_IDispatch||
			riid == diid) {
			if (ppvObject == NULL)
				return E_POINTER;
			*ppvObject = this;
			AddRef();
			return S_OK;
		} else {
			*ppvObject = 0;
			return E_NOINTERFACE;
		}
	}

	ULONG STDMETHODCALLTYPE AddRef() {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release() {
		return 1;
	}
	
	// -------------------------------------
	// IDispatch ̎
public:
	STDMETHOD (GetTypeInfoCount) (UINT* pctinfo)
	{
		return	E_NOTIMPL;
	}

	STDMETHOD (GetTypeInfo) (UINT itinfo, LCID lcid, ITypeInfo** pptinfo)
	{
		return	E_NOTIMPL;
	}

	STDMETHOD (GetIDsOfNames) (REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgdispid)
	{
		return	E_NOTIMPL;
	}

	STDMETHOD (Invoke) (DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult, EXCEPINFO* pexcepinfo, UINT* puArgErr)
	{
		// XXX sender ւ̃CxgM
		return S_OK;
	}
};
#endif

#include "IDispatchWrapper.hpp"

//---------------------------------------------------------------------------

/*
	vOCŃlCeBuꂽNX񋟂AggŎgpł悤
	łB

	lCeBuNX tTJSNativeInstance pNXɍ쐬ÃlC
	eBuNXƂ̃C^[tF[X tTJSNativeClassForPlugin x[Xɍ쐬
	܂B

	uTJS2 t@Xv́ugݍ݂̎v́u{IȎgvɂƓ
	NXł͍쐬܂BAvOCŎsATJS2 t@
	XɂƂ͎኱̎dقȂ邱ƂɒӂĂB
*/

//---------------------------------------------------------------------------
// eXgNX
//---------------------------------------------------------------------------

class iTJSDispatch2Method : public iTJSDispatch2Wrapper {
protected:
	ttstr name;
public:
	iTJSDispatch2Method(IDispatch *obj, const tjs_char *name) : iTJSDispatch2Wrapper(obj), name(name) {};
	virtual tjs_error Invoke(
		DWORD wFlags,
		const tjs_char * membername,
		tTJSVariant *result,
		tjs_int numparams,
		tTJSVariant **param
		) {
		return iTJSDispatch2Wrapper::Invoke(obj, wFlags, membername ? membername : name.c_str(), result, numparams, param);
	}
};

/*
	eIuWFNg (iTJSDispatch2 C^[tF[X) ɂ̓lCeBuCX^X
	Ă΂AiTJSNativeInstance ^̃IuWFNgo^邱ƂłA
	IuWFNgoƂł܂B
	܂AlCeBuCX^X̎łBlCeBuCX^Xɂ
	tTJSNativeInstance NX𓱏o܂BtTJSNativeInstance 
	iTJSNativeInstance ̊{IȓĂ܂B
*/
class NI_WIN32OLE : public tTJSNativeInstance // lCeBuCX^X
{
protected:
	IDispatch *pDispatch;
	
public:
	NI_WIN32OLE() {
		// RXgN^
		/*
			NI_WIN32OLE ̃RXgN^łBC++ NXƂĂ̏ q
			Construct ōς܂ĂAConstruct ł͍̏ŏ̕
			ɂ邱Ƃ߂܂B̗ł́Af[^o Value ɏ
			lƂ 0 ݒ肵Ă܂B
		 */
		pDispatch = NULL;
	}

	tjs_error TJS_INTF_METHOD
		Construct(tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *tjs_obj)
	{
		// TJS2 IuWFNg쐬ƂɌĂ΂
		/*
			TJS2  new Zq TJS2 IuWFNg쐬ƂɌĂ΂܂B
			numparams  param  new Zqɓnꂽ\Ă܂B
			tjs_obj ́A쐬 TJS IuWFNgłB
			̗ł́A (ɂꂪ void Ŗ)A Value
			̏lƂĐݒ肵Ă܂B
		 */

		if (numparams >= 1) {
			if (param[0]->Type() == tvtString) {
				const tjs_char *name = param[0]->GetString();
				HRESULT hr;
				CLSID   clsid;
				OLECHAR *oleName = SysAllocString(name);
				if (FAILED(hr = CLSIDFromProgID(oleName, &clsid))) {
					hr = CLSIDFromString(oleName, &clsid);
				}
				SysFreeString(oleName);
				if (SUCCEEDED(hr)) {
					// COM ڑIDispatch 擾
					/* get IDispatch interface */
					hr = CoCreateInstance(clsid, NULL, CLSCTX_INPROC_SERVER | CLSCTX_LOCAL_SERVER, IID_IDispatch, (void**)&pDispatch);
					if (SUCCEEDED(hr)) {

						log(TJS_W("ole load success %s"), name);
						
						// 擾p[^ TypeInfo oă\bhуvpeBSo^
						ITypeInfo *pTypeInfo = NULL;
						if (SUCCEEDED(hr = pDispatch->GetTypeInfo(0, LOCALE_SYSTEM_DEFAULT, &pTypeInfo))) {
							// 
							TYPEATTR  *pTypeAttr = NULL;
							if (SUCCEEDED(pTypeInfo->GetTypeAttr(&pTypeAttr))) {
								// ֐
								ttstr prevname;
								for (int iFunc = 0; iFunc < pTypeAttr->cFuncs; iFunc++) {
									FUNCDESC *pFuncDesc = NULL;
									if (FAILED(pTypeInfo->GetFuncDesc(iFunc, &pFuncDesc))) {
										continue;
									}
									if (!(pFuncDesc->wFuncFlags & (VARFLAG_FHIDDEN | VARFLAG_FRESTRICTED | VARFLAG_FNONBROWSABLE))) {
										BSTR bstr;
										unsigned int len;
										if (FAILED(pTypeInfo->GetNames(pFuncDesc->memid, &bstr, 1, &len)) || len == 0 || !bstr) {
											continue;
										}
#if 0
										// ޕ\
										// XXX ނɉă\bh̓eύXłقH
										// Ƃ肠Sꊇ iTJSDispatch2Method ɂ܂Ƃ߂Ă肷
										switch (pFuncDesc->invkind) {
										case INVOKE_FUNC:
											log(L"%d:method:%ls", iFunc, bstr);
											break;
										case INVOKE_PROPERTYGET:
											log(L"%d:propget:%ls", iFunc, bstr);
											break;
										case INVOKE_PROPERTYPUT:
											log(L"%d:propput:%ls", iFunc, bstr);
											break;
										}
#endif
										if (prevname != bstr) {
											iTJSDispatch2 *method = new iTJSDispatch2Method(pDispatch, bstr); 
											tTJSVariant m(method);
											method->Release();
											tjs_obj->PropSet(TJS_MEMBERENSURE|TJS_IGNOREPROP,
															 bstr,
															 NULL,
															 &m,
															 tjs_obj
															 );
											m.Clear();
										}
										
										prevname = bstr;
										SysFreeString(bstr);
									} else {
										prevname = "";
									}
									pTypeInfo->ReleaseFuncDesc(pFuncDesc);
								}
								pTypeInfo->ReleaseTypeAttr(pTypeAttr);
							}
							pTypeInfo->Release();
						}
						return TJS_S_OK;
					} else {
						log(TJS_W("CoCreateInstance failed %s"), name);
					}
				} else {
					log(TJS_W("bad CLSID %s"), name);
				}
			} 
			return TJS_E_INVALIDPARAM;
		} else {
			return TJS_E_BADPARAMCOUNT;
		}
	}

	void TJS_INTF_METHOD Invalidate()
	{
		// IuWFNgƂɌĂ΂
		if (pDispatch) {
			pDispatch->Release();
		}
	}

	/**
	 * \bhs
	 */
	tjs_error invoke(DWORD wFlags,
					 tTJSVariant *result,
					 tjs_int numparams,
					 tTJSVariant **param) {
		log(TJS_W("native invoke %d"), numparams);
		if (pDispatch) {
			// p[^̂Pڂ\bh
			if (numparams > 0) {
				if (param[0]->Type() == tvtString) {
					return iTJSDispatch2Wrapper::Invoke(pDispatch,
														wFlags,
														param[0]->GetString(),
														result,
														numparams - 1,
														param ? param + 1 : NULL);
				} else {
					return TJS_E_INVALIDPARAM;
				}
			} else {
				return TJS_E_BADPARAMCOUNT;
			}
		}
		return TJS_E_FAIL;
	}

};
//---------------------------------------------------------------------------
/*
	 NI_WIN32OLE ̃IuWFNg쐬ĕԂ̊֐łB
	q TJSCreateNativeClassForPlugin ̈Ƃēn܂B
*/
static iTJSNativeInstance * TJS_INTF_METHOD Create_NI_WIN32OLE()
{
	return new NI_WIN32OLE();
}
//---------------------------------------------------------------------------
/*
	TJS2 ̃lCeBuNX͈ӂ ID ŋʂĂKv܂B
	͌q TJS_BEGIN_NATIVE_MEMBERS }NŎIɎ擾܂A
	 ID i[ϐƁA̕ϐŐ錾܂B
	lɂ͖ ID \ -1 w肵ĂB
*/
#define TJS_NATIVE_CLASSID_NAME ClassID_WIN32OLE
static tjs_int32 TJS_NATIVE_CLASSID_NAME = -1;
//---------------------------------------------------------------------------
/*
	TJS2 ṕuNXv쐬ĕԂ֐łB
*/
static iTJSDispatch2 * Create_NC_WIN32OLE()
{
	/*
		܂ANX̃x[XƂȂNXIuWFNg쐬܂B
		ɂ TJSCreateNativeClassForPlugin p܂B
		TJSCreateNativeClassForPlugin ̑P̓NXAQ
		lCeBuCX^XԂ֐w肵܂B
		쐬IuWFNgꎞIɊi[郍[Jϐ̖O
		classobj łKv܂B
	*/
	tTJSNativeClassForPlugin * classobj = TJSCreateNativeClassForPlugin(TJS_W("WIN32OLE"), Create_NI_WIN32OLE);

	/*
		TJS_BEGIN_NATIVE_MEMBERS }NłBɂ TJS2 ŎgpNX
		w肵܂B
		̃}N TJS_END_NATIVE_MEMBERS }Nŋ܂ꂽꏊɁANX
		oƂȂׂ\bhvpeB̋Lq܂B
	*/
	TJS_BEGIN_NATIVE_MEMBERS(/*TJS class name*/WIN32OLE)

		/*
			 finalize \bh錾܂Bfinalize ɑ鏈
			tTJSNativeInstance::Invalidate I[o[Ch邱Ƃłł
			܂̂ŁAʏ͋̃\bhŏ\łB
		*/
		TJS_DECL_EMPTY_FINALIZE_METHOD

		/*
			(TJS) RXgN^錾܂BTJS ŃNXƂA
			NXŃNXƓ̃\bh錾Ă镔ɑ܂B

			TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL }N̂PԖڂ̈̓lCeBu
			CX^XɊ蓖ĂϐŁAQʖڂ̈͂̕ϐ̌^łB
			̗ł̂̃ubNł NI_WIN32OLE * _this Ƃϐp\ŁA
			lCeBuCX^XɃANZX邱Ƃł܂B
			}N̂RԖڂ̈́ATJS ŎgpNXw肵܂B
			TJS_END_NATIVE_CONSTRUCTOR_DECL }N̈lłB
			ARXgN^ɑ鏈 tTJSNativeInstance::Construct
			I[o[Ch鎖Ŏł̂ŁAł͉ S_OK 
			܂B
		*/
		TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL(
			/*var.name*/_this,
			/*var.type*/NI_WIN32OLE,
			/*TJS class name*/WIN32OLE)
		{
			// NI_WIN32OLE::Construct ɂeLqł̂
			// ł͉Ȃ
			return TJS_S_OK;
		}
		TJS_END_NATIVE_CONSTRUCTOR_DECL(/*TJS class name*/WIN32OLE)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/invoke) // invoke \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_WIN32OLE);
			log(TJS_W("invoke"));
			return _this->invoke(DISPATCH_METHOD, result, numparams, param);
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/invoke)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/set) // set \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_WIN32OLE);
			log(TJS_W("invoke"));
			return _this->invoke(DISPATCH_PROPERTYPUT, result, numparams, param);
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/set)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/get) // get \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_WIN32OLE);
			log(TJS_W("invoke"));
			return _this->invoke(DISPATCH_PROPERTYGET, result, numparams, param);
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/get)

			
	TJS_END_NATIVE_MEMBERS

	/*
		̊֐ classobj Ԃ܂B
	*/
	return classobj;
}
//---------------------------------------------------------------------------
/*
	TJS_NATIVE_CLASSID_NAME ͈ꉞ undef Ăق悢ł傤
*/
#undef TJS_NATIVE_CLASSID_NAME
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason,
	void* lpReserved)
{
	return 1;
}

extern void registArchive();
extern void unregistArchive();

//---------------------------------------------------------------------------
static tjs_int GlobalRefCountAtInit = 0;
static BOOL gOLEInitialized = false;

extern "C" HRESULT _stdcall _export V2Link(iTVPFunctionExporter *exporter)
{
	// X^ȕ(KLq)
	TVPInitImportStub(exporter);

	tTJSVariant val;

	// TJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	{
		//-----------------------------------------------------------------------
		// 1 ܂NXIuWFNg쐬
		iTJSDispatch2 * tjsclass = Create_NC_WIN32OLE();
		
		// 2 tjsclass  tTJSVariant ^ɕϊ
		val = tTJSVariant(tjsclass);
		
		// 3 ł val  tjsclass ێĂ̂ŁAtjsclass 
		//   Release 
		tjsclass->Release();
		
		
		// 4 global  PropSet \bhpAIuWFNgo^
		global->PropSet(
			TJS_MEMBERENSURE, // oȂꍇɂ͍쐬悤ɂtO
			TJS_W("WIN32OLE"), // o ( Ȃ炸 TJS_W( ) ň͂ )
			NULL, // qg ( {̓õnbVlANULL ł悢 )
			&val, // o^l
			global // ReLXg ( global ł悢 )
			);
		//-----------------------------------------------------------------------
	}

	// - global  Release 
	global->Release();

	// Ao^֐ꍇ 1 ` 4 JԂ

	// val NAB
	// ͕KsBȂ val ێĂIuWFNg
	//  Release ꂸAɎg TVPPluginGlobalRefCount mɂȂȂB
	val.Clear();

	// ̎_ł TVPPluginGlobalRefCount ̒l
	GlobalRefCountAtInit = TVPPluginGlobalRefCount;
	// ƂčTĂBTVPPluginGlobalRefCount ͂̃vOC
	// ǗĂ tTJSDispatch hIuWFNg̎QƃJE^̑vŁA
	// ɂ͂ƓAȂȂĂȂƂȂȂB
	// ȂĂȂ΁Aǂʂ̂ƂŊ֐ȂǂQƂĂāA
	// vOC͉łȂƌƂɂȂB

	if (!gOLEInitialized) {
		if (SUCCEEDED(OleInitialize(NULL))) {
			gOLEInitialized = true;
		} else {
			log(TJS_W("OLE s"));
		}
	}
	
	return S_OK;
}
//---------------------------------------------------------------------------
extern "C" HRESULT _stdcall _export V2Unlink()
{
	// ggAvOC悤ƂƂɌĂ΂֐B

	// 炩̏ŃvOCłȂꍇ
	// ̎_ E_FAIL Ԃ悤ɂB
	// ł́ATVPPluginGlobalRefCount  GlobalRefCountAtInit 
	// 傫ȂĂΎsƂƂɂB
	if(TVPPluginGlobalRefCount > GlobalRefCountAtInit) return E_FAIL;
		// E_FAIL AƁAPlugins.unlink \bh͋UԂ

	/*
		ANX̏ꍇAɁuIuWFNggpłvƂƂ
		m邷ׂ܂B{Iɂ́APlugins.unlink ɂvOC̉
		댯łƍlĂ ( Plugins.link ŃNAŌ
		ŃvOCAvOIƓɎIɉ̂g)B
	*/

	// TJS ̃O[oIuWFNgɓo^ WIN32OLE NXȂǂ폜

	// - ܂ATJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// - global  DeleteMember \bhpAIuWFNg폜
	if(global)
	{
		// TJS ̂ɉĂƂȂǂ
		// global  NULL ɂȂ蓾̂ global  NULL łȂ
		// Ƃ`FbN

		global->DeleteMember(
			0, // tO ( 0 ł悢 )
			TJS_W("WIN32OLE"), // o
			NULL, // qg
			global // ReLXg
			);
	}
	
	// - global  Release 
	if(global) global->Release();

	if (gOLEInitialized) {
		OleUninitialize();
		gOLEInitialized = false;
	}
	
	// X^u̎gpI(KLq)
	TVPUninitImportStub();

	return S_OK;
}
//---------------------------------------------------------------------------

